/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.blocks;

import java.util.Random;

import net.minecraft.block.BlockTorch;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.te.TETorchTFC;
import net.dries007.tfc.util.Helpers;
import net.dries007.tfc.util.OreDictionaryHelper;

/**
 * todo: add TE with timer
 */
public class BlockTorchTFC extends BlockTorch implements ITileEntityProvider
{
    public static final PropertyBool LIT = PropertyBool.func_177716_a("lit");

    public BlockTorchTFC()
    {
        super();
        func_180632_j(field_176227_L.func_177621_b().func_177226_a(field_176596_a, EnumFacing.UP).func_177226_a(LIT, true));
        OreDictionaryHelper.register(this, "torch");
        func_149715_a(0.9375F);
        Blocks.field_150480_ab.func_180686_a(this, 5, 20);
    }

    @Override
    public TileEntity func_149915_a(World worldIn, int meta)
    {
        return new TETorchTFC();
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void func_180655_c(IBlockState stateIn, World worldIn, BlockPos pos, Random rand)
    {
        if (!stateIn.func_177229_b(LIT)) return;
        super.func_180655_c(stateIn, worldIn, pos, rand);
    }

    @Override
    public IBlockState func_176203_a(int meta)
    {
        IBlockState state = func_176223_P().func_177226_a(LIT, (meta & 0b1000) == 0b1000);
        //TODO: I recommend to replace this with state.withProperty(FACING, EnumFacing.byIndex(meta & 0b0111)) - LS
        switch (meta & 0b0111)
        {
            default:
            case 0b0000:
                return state.func_177226_a(field_176596_a, EnumFacing.UP);
            case 0b0001:
                return state.func_177226_a(field_176596_a, EnumFacing.EAST);
            case 0b0010:
                return state.func_177226_a(field_176596_a, EnumFacing.WEST);
            case 0b0011:
                return state.func_177226_a(field_176596_a, EnumFacing.SOUTH);
            case 0b0100:
                return state.func_177226_a(field_176596_a, EnumFacing.NORTH);
        }
    }

    @Override
    public int func_176201_c(IBlockState state)
    {
        int meta = state.func_177229_b(LIT) ? 0b1000 : 0;
        //TODO: I recommend to replace this with state.getValue(FACING).getIndex() - LS
        switch (state.func_177229_b(field_176596_a))
        {
            default:
            case UP:
                return meta | 0b0000;
            case EAST:
                return meta | 0b0001;
            case WEST:
                return meta | 0b0010;
            case SOUTH:
                return meta | 0b0011;
            case NORTH:
                return meta | 0b0100;
        }
    }

    @Override
    protected BlockStateContainer func_180661_e()
    {
        return new BlockStateContainer(this, field_176596_a, LIT);
    }

    @Override
    public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn, EnumHand hand, EnumFacing facing, float hitX, float hitY, float hitZ)
    {
        if (worldIn.field_72995_K) return true;

        TETorchTFC te = Helpers.getTE(worldIn, pos, TETorchTFC.class);
        if (te == null) return true;
        te.toggle();
        return true;
    }

    @Override
    public int getLightValue(IBlockState state, IBlockAccess world, BlockPos pos)
    {
        return state.func_177229_b(LIT) ? super.getLightValue(state, world, pos) : 0;
    }
}
