/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 *
 */

package net.dries007.tfc.objects.container;

import javax.annotation.Nonnull;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;

import net.dries007.tfc.objects.te.TESidedInventory;

public abstract class ContainerTE<TE extends TESidedInventory> extends Container
{
    protected TE tile;

    ContainerTE(InventoryPlayer playerInv, TE te)
    {
        this.tile = te;

        addContainerSlots();
        addPlayerInventorySlots(playerInv);
    }

    @Override
    @Nonnull
    public ItemStack func_82846_b(EntityPlayer player, int index)
    {
        // Slot that was clicked
        Slot slot = field_75151_b.get(index);
        if (slot == null || !slot.func_75216_d())
            return ItemStack.field_190927_a;

        ItemStack stack = slot.func_75211_c();
        ItemStack stackCopy = stack.func_77946_l();

        // Transfer out of the container
        int containerSlots = field_75151_b.size() - player.field_71071_by.field_70462_a.size();
        if (index < containerSlots)
        {
            if (!this.func_75135_a(stack, containerSlots, field_75151_b.size(), true))
            {
                return ItemStack.field_190927_a;
            }
            tile.setAndUpdateSlots(index);
        }
        // Transfer into the container
        else
        {
            if (!this.func_75135_a(stack, 0, containerSlots, false))
            {
                return ItemStack.field_190927_a;
            }
        }

        if (stack.func_190916_E() == 0)
        {
            slot.func_75215_d(ItemStack.field_190927_a);
        }
        else
        {
            slot.func_75218_e();
        }
        if (stack.func_190916_E() == stackCopy.func_190916_E())
        {
            return ItemStack.field_190927_a;
        }
        slot.func_190901_a(player, stack);
        return stackCopy;
    }

    @Override
    public boolean func_75145_c(@Nonnull EntityPlayer player)
    {
        return true;
    }

    protected abstract void addContainerSlots();

    private void addPlayerInventorySlots(InventoryPlayer playerInv)
    {
        // Add Player Inventory Slots
        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < 9; j++)
            {
                func_75146_a(new Slot(playerInv, j + i * 9 + 9, 8 + j * 18, 84 + i * 18));
            }
        }

        for (int k = 0; k < 9; k++)
        {
            func_75146_a(new Slot(playerInv, k, 8 + k * 18, 142));
        }
    }
}
